class SubjectBuilder < Builder
  ##
  # receive a list of ids and return a list of subjects
  #
  # Example:
  #   subject = SubjectBuilder.build '#15:135'
  #   subjects = SubjectBuilder.build [{'@rid' => '#15:135'}, {'@rid' => '#15:140'}, {'@rid' => '#15:136'}]
  #   subjects = SubjectBuilder.build [{'@rid' => '#15:135', 'last_modified' => '2015-30-10 15:44:12'}, {'@rid' => '#15:140'}, {'@rid' => '#15:136'}]
  def self.build(subjects = [])
    super(subject_repository, subjects)
  end

  def self.build_from_orientdb(args = {})
    super(args) do
      Orientdb::Subject.new(
        id: args['@rid'],
        name: args['name'],
        created_at: args['created_at'],
        last_modified: args['last_modified']
      )
    end
  end

end
