class Management::ComplaintsController < ManagementController
  include RepositoriesProxy
  before_action :set_complaint, only: :destroy

  def index
    @complaints = complaint_repository.all
  end

  def destroy
    complaint_repository.destroy @complaint

    respond_to do |format|
      format.html { redirect_to :back, notice: 'Denúncia excluída com sucesso.' }
    end
  end

  private

  def set_complaint
    @complaint = complaint_repository.find params[:id]
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def complaint_params
    params.require(:complaint).permit(:id, :object, :message, :description)
  end
end
