class Role < ActiveRecord::Base
  has_and_belongs_to_many :users

  validates_presence_of :name
  validates_uniqueness_of :name

  def self.admin
    self.find_by_name('admin') || self.create!(name: 'admin')
  end

  def self.teacher
    self.find_by_name('teacher') || self.create!(name: 'teacher')
  end

  def self.curator
    self.find_by_name('student') || self.create!(name: 'student')
  end
end
