class DspaceUploadWorker
  include Sidekiq::Worker

  @@dspace= nil

  def perform(learning_object_id, item_id, media_path, *options)
    # create file instance
    file = File.new(media_path, 'r')

    #create bitstream in dspace
    bitstream = dspace.items.add_bitstream(file, id: item_id, name: File.basename(media_path), description: get_description(options))

    #find learning object
    learning_object = LearningObject.find learning_object_id
    learning_object.attachments.create map_bitstream2attachment(bitstream)
    publisher.publish! learning_object
  end

  private

  def map_bitstream2attachment(bitstream)
    {id_dspace: bitstream.id, name: bitstream.name, link: bitstream.link,
     retrieve_link: bitstream.retrieve_link, description: bitstream.description,
     format: bitstream.format, mime_type: bitstream.mime_type, size: bitstream.size_bytes,
     bundle_name: bitstream.bundle_name}
  end

  def publisher
    @publisher ||= LearningObjectPublisher.new(dspace)
  end

  def dspace
    @@dspace ||= DspaceService.create_client
  end

  def get_description(*options)
    description = nil
    if options.has_key? :description
      description = options[:description]
    end
    description
  end

end